var ansimator = require("../lib/ansimator")(process);
var EE = require("events").EventEmitter;

var width = 40,
    height = 8;

var frames = [
  ""
];

var logger = new EE();


var lineBreak = function (frame) {
  return frame.split("\n").map(function (l) {
    if ( l.length > width ) {

      var c = width;
      while( l[c] !== " ") {
        c--;
      }

      return l.slice(0, c) + "\n" + l.slice(c+1);

    } else {
      return l;
    }

  }).join("\n");

}


var clipHeight = function (frame) {
  var xs;

  if (frame.length === 0 ) {
    xs = [];
  } else {
    xs = frame.split("\n");
  }

  if (xs.length > height) {
    xs = xs.slice(1);
  }

  return xs.join("\n");
}


var logbox = ansimator(frames).move(0, 2, function (logbox) {
  logger.on("data", function (data) {

    if (logbox.frames[0].length > 0) {
      data = logbox.frames[0]+"\n"+data;
    }

    logbox.frames[0] = clipHeight(lineBreak(data));
    logbox.next();
  });
});

logbox.charm.on("^C", function () {
  logbox.charm.reset(true);
  logbox.charm.destroy();
  process.exit();
});

var i = 0;
setInterval(function () {
  logger.emit("data", "THE B"+String(i++)+"ST!");
}, 500);
