var charmer = require("charm");

module.exports = function () {
  var charm = charmer.apply(charmer, arguments);

  return function (frames) {
    var x = 0,
        y = 0,
        f = 0;

    charm.write("\n").up(1);

    var ansimator = {
      frames: frames,
      position: function (i,j) {
        x = i;
        y = j;
        charm.position(x,y);
        return ansimator;
      },
      move: function (i, j, cb) {
        // fire/forget. This is a race condition.
        charm.position(function (m, n) {
          x = m + i;
          y = n + j;
          cb(ansimator);
        });

        return ansimator;
      },
      next: function () {
        charm.push(true);

        charm.position(x,y);

        ansimator.frames[f].split("\n").forEach(function (l) {
          charm.column(x).write(l+"\n");
        });

        f = (f + 1) % frames.length;

        charm.pop(true);
      },
      charm: charm
    };

    return ansimator;

  };
}
